if exists(select 1 from sys.sysprocedure where proc_name='Report_PeopleStat1') then
   drop procedure Report_PeopleStat1;
end if;
commit;

CREATE  PROCEDURE "Admin"."Report_PeopleStat1"(in in_PersonID integer,in in_UserID integer)
result(SN varchar(255),FN varchar(255),City varchar(100),sex integer,BirthCountry varchar(100),Country1 varchar(100),PasNumber varchar(100),PasSer varchar(100),MigrNumber varchar(100),MigrSer varchar(100),DocType varchar(100),VN1 varchar(20),VN2 varchar(20),VS date,VE date,ArrivalPoint varchar(255),PD date,PE date,BD date,APName varchar(100),AP integer,PN varchar(100),BDD date,GroupNum integer,DepDate date,RoomNumber varchar(20),ArrDate date,Profession varchar(40),NoVisa integer,isVisa integer,isVid integer,isRazr integer,RecCompany varchar(150),HTName varchar(100),HTPhone varchar(50),HTINN varchar(30),HotAddress varchar(100),HTCountry varchar(100),HTCity varchar(100),HTDistrict varchar(100),HTStreet varchar(100),HTHouse varchar(5),HTKorp varchar(5),HTStr varchar(5),UsSN varchar(100),USFN varchar(100),USDocType varchar(100),USDocSer varchar(100),USDocNum varchar(100),USDocID date,USDocED date,USObl varchar(100),USDistr varchar(100),USCity varchar(100),USStreet varchar(100),USHouse varchar(5),USKorp varchar(5),USStr varchar(5),USFlat varchar(10),USPhone varchar(20),USBirthDay date,NoteForForeigner varchar(255),DepDate_plus_1 date,PName varchar(255),PSname varchar(255),MainRoomtyp integer,PersonPhone varchar(50),ConfirmDoc varchar(255),Zak_pred varchar(500),USRN varchar(100),SN_LAT varchar(255),FN_LAT varchar(255),REF_LAT varchar(255))
begin
  -----------------------------------------------------------------------------
  --26.02.2008 -- KQ -- Created
  --05.06.2008 -- F9 -- Add MigrNumber,MigrSer
  --01.06.2009 -- F9 -- Add SurnameForeigner,FirstNameForeigner
  --21.09.2009 -- F9 -- Add BirthCountry
  --10.03.2010 -- F9 -- Add ReceivingCompany (for ITL)
  --27.05.2010 -- F9 -- Add VISASERIES
  --23.06.2010 -- F9 -- Add UserBirthDay
  --14.07.2010 -- F9 -- Add HotAddress
  --13.09.2010 -- F9 -- Add isVid,isRazr,ArrivalPoint
  --23.09.2010 -- F9 -- Add NoVisa
  --08.11.2010 -- F9 -- edit BirthPlace
  --18.02.2011 -- F9 -- add HTDistrict
  --10.03.2011 -- F9 -- add Profession,add APName
  --14.10.2011 -- KH -- add NoteForForeigner (  )
  --09.08.2012 -- KH --  .  jurPer 
  --15.11.2013 -- KH -- +   +1
  --31.01.2014 -- Add ImCardSeries as MigrSer
  --08.05.2014 -- NN -- add INN from juridicalpersons (for the Riv'yera)
  --22.01.2014 -- NN -- add Name and Surname
  --16.09.2019 -- KH -- add Guest Phone
  --31.10.2019 -- KH -- add hotConfirmation_Doc 
  --09.02.2021 -- KH:    . +  (,) 
  --19.02.2021 -- KH:  . +  
  --26.02.2021 -- LA:     
  --01.03.2021 -- KH:   
  --14.10.2021 -- KH: (CASE WHEN length(mobilephone) > 0 THEN mobilephone ELSE homeaddressphone end)
  --02.02.2022 -- KH      .
  --13.01.2023 -- KH  
  --22.05.2023 -- KH - HotelSurname
  --13.03.2024 -- LA - HotelSurname - > TITLE
  --03.02.2025 -- KH - add UPPER(A_Surn_lat),UPPER(A_FirstN_lat)
  --05.02.2025 -- KH - add A_Ref_lat + toLatin  Surname  FirstName
  --21.02.2025 -- KH - /  Ascii
  -----------------------------------------------------------------------------
  declare hotAddress varchar(255);
  declare hotConfirmation_Doc varchar(255);
  declare hotOblast varchar(255);
  declare hotDistrict varchar(255);
  declare hotStreet varchar(255);
  declare hotHouse varchar(255);
  declare hotKorp varchar(255);
  declare hotStroen varchar(255);
  declare A_Surn varchar(255);
  declare A_FirstN varchar(255);
  declare A_Surn_lat varchar(255);
  declare A_FirstN_lat varchar(255);
  declare A_Ref_lat varchar(255);
  declare PNamet varchar(255);
  declare PSnamet varchar(255);
  declare House_locale integer;
  declare House_locale_delta integer;
  declare ResponsableUser integer;
  declare JP_ID integer;
  set JP_ID=1;
  set HotAddress='';
  set hotDistrict='';
  set hotStreet='';
  set hotHouse='';
  set hotKorp='';
  set hotStroen='';
  set A_Surn='';
  set A_FirstN='';
  set A_Surn_lat='';
  set A_FirstN_lat='';
  set A_Ref_lat='';
  set PNamet='';
  set PSnamet='';
  set hotConfirmation_Doc='';
  set House_locale=0;
  set House_locale_delta=0;
  --
  set ResponsableUser=(case when(select first isnull(ToAdminID,0) into RespUserID from USERPERSONDATA where isResponsible = 1) > 0 then
      (select first isnull(ToAdminID,0) into RespUserID from USERPERSONDATA where isResponsible = 1) else in_UserID end);
  select min(isnull(JURIDICALPERSID,1)) into JP_ID from accounts where OWNERID = in_PersonID and ISPACKACCOUNT = 1;
  if JP_ID is null or JP_ID = 0 then select min(isnull(ID,1)) into JP_ID from JURIDICAL_PERSONS where isActive = 1
  end if;
  select UPPER(HotelAddress),UPPER(CONFIRMATION_DOCUMENT) into hotAddress,hotConfirmation_Doc from JURIDICAL_PERSONS where ID = JP_ID;
  --
  if Locate(HotAddress,'.,') > 0 then
    set hotOblast=SubStr(HotAddress,1,locate(HotAddress,'.,')+4);
    set HotAddress=LTRIM(SubStr(HotAddress,locate(HotAddress,'.,')+5,255))
  end if;
  --
  if Locate(HotAddress,',') > 0 then
    set hotOblast=SubStr(HotAddress,1,locate(HotAddress,',')+6);
    set HotAddress=LTRIM(SubStr(HotAddress,locate(HotAddress,',')+8,255))
  end if;
  --
  if Locate(HotAddress,'-') > 0 then
    set hotDistrict=LTRIM(SubStr(HotAddress,1,locate(HotAddress,'-')+3))
  end if;
  --
  if Locate(HotAddress,'.') > 0 then
    set House_locale=Locate(HotAddress,'.');
    set House_locale_delta=2
  elseif Locate(HotAddress,' ') > 0 then
    set House_locale=Locate(HotAddress,' ');
    set House_locale_delta=4
  else
    set House_locale=0
  end if;
  --    
  if House_locale > 0 then
    if Locate(HotAddress,'-') > 0 then
      set hotStreet=Replace(Trim(SubStr(HotAddress,locate(HotAddress,'-')+5,(House_locale-1-(locate(HotAddress,'-')+5)))),',','')
    else
      set hotStreet=SubStr(HotAddress,1,House_locale-1)
    end if;
    if Locate(HotAddress,'.') > 0 then
      set hotHouse=Replace(Trim(SubStr(HotAddress,House_locale+House_locale_delta,(locate(HotAddress,'.')-(House_locale+House_locale_delta)))),',','');
      if Locate(HotAddress,'.') > 0 then
        set hotKorp=Replace(Trim(SubStr(HotAddress,locate(HotAddress,'.')+5,(locate(HotAddress,'.')-(locate(HotAddress,'.')+5)))),',','');
        set hotStroen=Replace(Trim(SubStr(HotAddress,locate(HotAddress,'.')+4,(length(HotAddress)+1-(locate(HotAddress,'.')+4)))),',','')
      else
        set hotKorp=Replace(Trim(SubStr(HotAddress,locate(HotAddress,'.')+5,(length(HotAddress)+1-(locate(HotAddress,'.')+5)))),',','')
      end if
    else
      if Locate(HotAddress,'.') > 0 then
        set hotHouse=Replace(Trim(SubStr(HotAddress,House_locale+House_locale_delta,(locate(HotAddress,'.')-(House_locale+House_locale_delta)))),',','');
        set hotStroen=Replace(Trim(SubStr(HotAddress,locate(HotAddress,'.')+4,(length(HotAddress)+1-(locate(HotAddress,'.')+4)))),',','')
      else
        set hotHouse=Replace(Trim(SubStr(HotAddress,House_locale+House_locale_delta,(length(HotAddress)+1-(House_locale+House_locale_delta)))),',','')
      end if
    end if
  else
    set hotStreet=HotAddress
  end if;
  --  + 
    SELECT (if length(Person.Surname) < 1 or Ascii("Left"(Trim(Person.Surname),1)) < 127 THEN (if length(Person.SurnameForeigner) < 1 or Ascii("Left"(Trim(Person.SurnameForeigner),1)) < 127 then '' else
    TRIM(cast(Person.SurnameForeigner as varchar(50))) endif) else TRIM(cast(Person.Surname as varchar(50))) endif) into A_Surn from Person where Id = in_PersonID;
    --
    select (if length(Person.FirstName) < 1 or Ascii("Left"(Trim(Person.FirstName),1)) < 127 THEN (if length(Person.FirstnameForeigner) < 1 or Ascii("Left"(Trim(Person.FirstnameForeigner),1)) < 127 then '' else
    TRIM(cast(Person.FirstnameForeigner as varchar(50))) endif) else TRIM(cast(Person.FirstName as varchar(50))) endif) into A_FirstN from Person where Id = in_PersonID;
    --
    select (if length(Person.Reference1) < 1 or Ascii("Left"(Trim(Person.Reference1),1)) < 127 THEN (if length(Person.ReferenceForeigner) < 1 or Ascii("Left"(Trim(Person.ReferenceForeigner),1)) < 127 then '' else
    TRIM(cast(Person.ReferenceForeigner as varchar(50))) endif) else TRIM(cast(Person.Reference1 as varchar(50))) endif) into PSnamet from Person where Id = in_PersonID;
    --
    select (if length(Person.Surname) < 1 or Ascii("Left"(Trim(Person.Surname),1)) > 127 THEN (if length(Person.SurnameForeigner) < 1 or Ascii("Left"(Trim(Person.SurnameForeigner),1)) > 127 then EasyConvertToLatin(Person.Surname) else
    TRIM(cast(Person.SurnameForeigner as varchar(50))) endif) else TRIM(cast(Person.Surname as varchar(50))) endif) into A_Surn_lat from Person where Id = in_PersonID;
    --
    select (if length(Person.FirstName) < 1 or Ascii("Left"(Trim(Person.FirstName),1)) > 127 THEN (if length(Person.FirstnameForeigner) < 1 or Ascii("Left"(Trim(Person.FirstnameForeigner),1)) > 127 then EasyConvertToLatin(Person.FirstName) else
    TRIM(cast(Person.FirstnameForeigner as varchar(50))) endif) else TRIM(cast(Person.FirstName as varchar(50))) endif) into A_FirstN_lat from Person where Id = in_PersonID;
    --
    select (if length(Person.Reference1) < 1 or Ascii("Left"(Trim(Person.Reference1),1)) > 127 THEN (if length(Person.ReferenceForeigner) < 1 or Ascii("Left"(Trim(Person.ReferenceForeigner),1)) > 127 then EasyConvertToLatin(Person.Reference1) else
    TRIM(cast(Person.ReferenceForeigner as varchar(50))) endif) else TRIM(cast(Person.Reference1 as varchar(50))) endif) into A_Ref_lat from Person where Id = in_PersonID;
  --
  select UPPER(A_Surn),UPPER(A_FirstN),
    UPPER(P.City),P.sex,
    isnull((select UPPER(trim(PersonNation.Name)) from PersonNation join Persons_BirthPlace on
      PersonNation.ID = Persons_BirthPlace.State where
      Persons_BirthPlace.ID = P.BirthAdressId),UPPER(trim(PersonNation.NAME))),
    (if(select length(trim(Persons_BirthPlace.SETTLEMENT)) from Persons_BirthPlace where Persons_BirthPlace.ID = P.BirthAdressId) > 0 then
      (select UPPER(Persons_BirthPlace.SETTLEMENT) from Persons_BirthPlace where Persons_BirthPlace.ID = P.BirthAdressId)
    else
      UPPER(P.BirthPlace)
    endif),UPPER("LEFT"(P.PassNumber,13)),UPPER("LEFT"(P.PassText,4)),
    ImCardNumber,
    ImCardSeries,
    isnull((select UPPER(IC.Signature) from IdentityCardType as IC where IC.ID = P.IdentityCardTypeID),''),
    --
    (if exists(select 1 from sys.syscolumns where tname = 'Person' and cname = 'VISASERIES') then P.VisaNumber
    else
      UPPER(isnull(SubStr(VisaNumber,locate(VisaNumber,' ')+1,13),' '))
    endif),
    (if exists(select 1 from sys.syscolumns where tname = 'Person' and cname = 'VISASERIES') then P.VISASERIES
    else
      UPPER(isnull(SubStr(VisaNumber,1,locate(VisaNumber,' ')-1),' '))
    endif),VisaDate,VisaExpireDate,UPPER(ArrivalPoint),PassissueDate,PassExpireDate,P.BirthDate,
    (select name from ArrivalPurpose where id = P.ArrivalPurposeid) as APname,
    (if APname like '%%' then 1 else if APname like '%%' then 2 else if APname like '%%' then 3
        else if APname like '%%' then 4 else if APname like '%%' then 5 else if APname like '%%' then 6
              else if APname like '%%' then 7 else if APname like '%%' then 8
                  else 0
                  endif endif
              endif endif endif
        endif endif endif),UPPER(trim(PersonNation.NAME)),P.BorderDate,ResNum,ShowDepartureDate,Room.Number,
    Arrival,UPPER(P.Profession),
    (if(trim(P.VisaNumber) = '-' or trim(P.VisaNumber) = '' or P.VisaDocTypeID = 0) then 1 else 0 endif),
    (if(select Isnull(Name,'-') from VisaDocType where ID = P.VisaDocTypeID) like '%%' then 1 else 0 endif),
    (if(select Isnull(Name,'-') from VisaDocType where ID = P.VisaDocTypeID) like '%%' then 1 else 0 endif),
    (if(select Isnull(Name,'-') from VisaDocType where ID = P.VisaDocTypeID) like '%.%' then 1 else 0 endif),
    P.ReceivingCompany,
    UPPER(JP.TITLE),JP.HOTELPHONE,JP.INN,UPPER(JP.HOTELADDRESS),UPPER(JP.HOTELCOUNTRY+' '+hotOblast),UPPER(JP.HOTELCITY),UPPER(hotDistrict),UPPER(hotStreet),hotHouse,hotKorp,hotStroen,
    UPPER(US.Surname),UPPER(US.Firstname),
    UPPER(US.IdentityCardType),UPPER(US.IdentityCardSeries),UPPER(US.IdentityCardNumber),US.IdentityCardIssue,US.IdentityCardExpire,
    UPPER(US.HomeAddressOblast),UPPER(US.HomeAddressDistrict),UPPER(US.HomeAddressCity),UPPER(US.HomeAddressStreet),Trim(US.HomeAddressHouse),Trim(US.HomeAddressHousing),
    Trim(US.HomeAddressBuilding),Trim(US.HomeAddressFlat),Trim(case when length(US.mobilephone) > 0 then US.mobilephone else US.homeaddressphone end),US.UserBirthDay,
    (case when P.LivingAdressPrevID > 0 then(select UPPER(REGION+' '+DISTRICT+' '+SETTLEMENT+' '+STREET+' '+HOUSE+' '+BUILDING+' '+FLAT) from PERSONS_LIVINGADDRESS_PREV where ID = P.LivingAdressPrevID)
    else UPPER(P.NoteForForeigner)
    end),ShowDepartureDate+1,PNamet,UPPER(PSnamet),(select maintypeid from roomtype where id = room.typeid),TRIM(UPPER(isnull(P.PHONE,'',P.PHONE))),UPPER(hotConfirmation_Doc),
    UPPER(case when legalRepresentative > 0 then(select Surname+' '+FIRSTNAME+' '+REFERENCE1+' '+cast(DateFormat(BirthDate,'dd.mm.yyyy') as varchar) from permanentguest where id = legalRepresentative)
    else '' end),UPPER(US.userReference),UPPER(A_Surn_lat),UPPER(A_FirstN_lat),UPPER(A_Ref_lat) from
    person as P,PersonNation,reserve,period,room left outer join JURIDICAL_PERSONS as JP on JP.ID = JP_ID left outer join
    USERPERSONDATA as US on US.ToAdminID = ResponsableUser where
    p.id = in_PersonID and P.Reservid = Reserve.ID and Reserve.ID = Period.ReservID and
    PersonNation.id = P.NationID and Period.RoomID = Room.ID and Period.SuperperiodID = 0 and
    Period.TypeID in( 0,1) 
end;
commit;